<?php
/* * **************************************************************************** */

//                          InstantCMS v1.10                                   //
//                      http://www.instantcms.ru/                              //
//                         plugin p_ad_block v1.1.0                            //
//                     written by Marat Fatikhov  aka Марат                    //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/* * ***************************************************************************** */

class p_ad_block extends cmsPlugin {

// ==================================================================== //

    public function __construct() {

        parent::__construct();

        // Информация о плагине

        $this->info['plugin'] = 'p_ad_block';
        $this->info['title'] = 'Рекламные блоки на странице';
        $this->info['description'] = 'Устанавливает рекламные блоки для любой страницы любого компонента';
        $this->info['author'] = 'Marat Fatikhov';
        $this->info['version'] = '1.1.0';

        // Настройки по-умолчанию
        $this->config['Выводить блок под заголовком. 1-да,0-нет'] = 1;
        $this->config['Выводить второй блок. 1-да,0-нет'] = 0;
        $this->config['Разный код вызова для блоков. 1-да,0-нет'] = 0;
        $this->config['Класс блока, над которым выводить второй блок'] = 'cmm_heading';

        // События, которые будут отлавливаться плагином
        $inCore = cmsCore::getInstance();
        $components = array();
        $components = $inCore->getComponentsDirs();

        foreach ($components as $component) {
            if ($component != 'search' || $component != 'comments') {
                $this->events[] = 'AFTER_COMPONENT_' . mb_strtoupper($component);
            }
        }
    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install() {

        return parent::install();
    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade() {

        return parent::upgrade();
    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item) {

        parent::execute();

        $item = $this->sendAdBlock($item);

        return $item;
    }

// ==================================================================== //

    private function sendAdBlock($item) {

        $code_1 = '';
        $code_2 = '';

        ob_start();
        ?>
        <!--  НАЧАЛО КОДА ПЕРВОГО РЕКЛАМНОГО БЛОКА-->
        
        <!--  КОНЕЦ КОДА ПЕРВОГО РЕКЛАМНОГО БЛОКА-->
        <?php
        $code_1 = ob_get_clean();
        if($this->config['Выводить второй блок. 1-да,0-нет'] && 
           $this->config['Разный код вызова для блоков. 1-да,0-нет']) {
            ob_start();
            ?>
            <!--  НАЧАЛО КОДА ВТОРОГО РЕКЛАМНОГО БЛОКА-->
            
            <!--  КОНЕЦ КОДА ВТОРОГО РЕКЛАМНОГО БЛОКА-->
            <?php
            $code_2 = ob_get_clean();
        }
        //вывод блока под заголовком
        if ($this->config['Выводить блок под заголовком. 1-да,0-нет']) {
            $source = '/<(?:div|h1) (?:class="con_heading"|class="h_movie")(.*?)>(.*?)<\\/(?:div|h1)>/is';
            $replacement = '<h1 class="con_heading"$1>$2</h1>
            <div style="margin-top:15px; margin-bottom:15px;">' . $code_1 . '</div>';
            $item = preg_replace($source, $replacement, $item);
        }
        //вывод блока под содержимым работы компонента
        //если разный код для блоков, выводим $code_2, иначе $code_1
        $code = '';
        $code = ($this->config['Разный код вызова для блоков. 1-да,0-нет']) ? $code_2 : $code_1;

        if ($this->config['Выводить второй блок. 1-да,0-нет']) {
            $div_class = $this->config['Класс блока <div>, над которым выводить второй блок']?
                         $this->config['Класс блока <div>, над которым выводить второй блок']: 'cmm_heading';
            $source = '/<(?:div) (?:class="'.$div_class.'")(.*?)>(.*?)<\\/(?:div)>/is';
            $replacement = '<div style="margin-top:15px; margin-bottom:15px;">' . $code . '</div>
            <div class="'.$div_class.'"$1>$2</div>';
            $count = 0;
            $item = preg_replace($source, $replacement, $item, -1, $count);
            //если замен не было, то вставляем блок в конец
            if(!$count){
            $item .= '<div style="margin-top:15px; margin-bottom:15px;">' . $code . '</div>';
            }
      
        }

        return $item;
    }

//==============================================================================//
}//class
?>
